      SUBROUTINE COLLCAD_chris(XTRACK,YTRACK,ZTRACK,NTRACK,MTRACK,
     +JTRACK,ETRACK,WTRACK,PARTNAME,HISTORY,KINORTOT,ATRACK,NCASE)
c
c  This programme was developed and programmed by Helmut Vincke
c  
c
      CHARACTER PARTNAME*3
      INTEGER NTRACK,MTRACK,JTRACK,COUNT,HISTORY,KINORTOT,NCASE,NCASEOLD
      DOUBLE PRECISION XTRACK(0:100000),YTRACK(0:100000),
     + ZTRACK(0:100000),ETRACK,WTRACK, MASS(-6:42), ATRACK, ATRACKMAX
      LOGICAL NEWLAYER(-6:42)
      DOUBLE PRECISION TIMEST(0:100000),SPEED,DIST,ENERGY
      SAVE NCASEOLD
      SAVE ATRACKSUM
      SAVE ATRACKMAX
      DATA  NCASEOLD /0/
      DATA  ATRACKSUM /0.0D0/
      DATA  ATRACKMAX /0.0D0/
c
c Masse der einzelnen Teilchen in GeV
c
      mass (-6)=0.3727380257E+01
      mass (-5)=0.2808392237E+01
      mass (-4)=0.2808921774E+01
      mass (-3)=0.1875613390E+01
      mass (-2)=0.0000000000E+00
      mass (-1)=0.0000000000E+00
      mass ( 0)=0.0000000000E+00
      mass ( 1)=0.9382723100E+00
      mass ( 2)=0.9382723100E+00
      mass ( 3)=0.5109990600E-03
      mass ( 4)=0.5109990600E-03
      mass ( 5)=0.0000000000E+00
      mass ( 6)=0.0000000000E+00
      mass ( 7)=0.0000000000E+00
      mass ( 8)=0.9395656300E+00
      mass ( 9)=0.9395656300E+00
      mass (10)=0.1056583890E+00
      mass (11)=0.1056583890E+00
      mass (12)=0.4976710000E+00
      mass (13)=0.1395699500E+00
      mass (14)=0.1395699500E+00
      mass (15)=0.4936460000E+00
      mass (16)=0.4936460000E+00
      mass (17)=0.1115630000E+01
      mass (18)=0.1115630000E+01
      mass (19)=0.4976710000E+00
      mass (20)=0.1197430000E+01
      mass (21)=0.1189370000E+01
      mass (22)=0.1192550000E+01
      mass (23)=0.1349764000E+00
      mass (24)=0.4976710000E+00
      mass (25)=0.4976710000E+00
      mass (26)=0.1349764000E+00
      mass (27)=0.0000000000E+00
      mass (28)=0.0000000000E+00
      mass (29)=0.5474500000E+00
      mass (30)=0.0000000000E+00
      mass (31)=0.1189370000E+01
      mass (32)=0.1192550000E+01
      mass (33)=0.1197430000E+01
      mass (34)=0.1314900000E+01
      mass (35)=0.1314900000E+01
      mass (36)=0.1321320000E+01
      mass (37)=0.1321320000E+01
      mass (38)=0.1672430000E+01
      mass (39)=0.1672430000E+01
      mass (40)=0.9395656300E+00
      mass (41)=0.1777000000E+01
      mass (42)=0.1777000000E+01
C
      
*      CHECK IF NEW HISTORY 
*
      IF (NCASE .NE. NCASEOLD) THEN
        ATRACKSUM = ATRACKSUM + ATRACKMAX
	ATRACKMAX = 0.0D0
	NCASEOLD = NCASE
      ENDIF 	
*
      IF( JTRACK .LT. -6 .OR. JTRACK .GT. 42 ) THEND
        WRITE(*,*)'** WARNING: Unknown particle ',JTRACK,' encountered!'
        WRITE(*,*)'**          Event: ',NCASE,' tot. Energy: ',ETRACK
	WRITE(*,*)'**          Track skipped!'
        RETURN
      END IF

      WRITE(35,*)
      WRITE(35,'(A8)')'PARTICLE' 
      DO  I= (NTRACK-1),0,-1
        DIST=sqrt((XTRACK(I+1)-XTRACK(I))**2+(YTRACK(I+1)-YTRACK(I))**2
     +       +(ZTRACK(I+1)-ZTRACK(I))**2) 
C  CALCULATION OF SPEED OF PARTICLE IN CM/S
        ENERGY = ETRACK
        speed = 29979245800.0D0 * SQRT( 1.0D0 -(MASS(JTRACK)/ENERGY)**2)
	WRITE (97,*)speed, ((ETRACK/MASS(JTRACK))**2)
c  time stamp of the point in seconds
        IF (I.eq. (NTRACK-1) ) THEN
	  timest(NTRACK) = ATRACK + ATRACKSUM
	ENDIF  
        timest(I) = timest(I+1) - DIST/speed	
        IF (ATRACK .GT. ATRACKMAX) THEN
	  ATRACKMAX = ATRACK
	ENDIF  
      ENDDO 
* track point of particle 
      DO I = 0, NTRACK
         IF (timest(I) .LT. 0.0D0) THEN
           timest(I) = 0.0D0
         ENDIF  
         WRITE(35,'(1P,SP,A2,4(D22.15,A1))')'s ',XTRACK(I),',',
     +   YTRACK(I),',',ZTRACK(I),' ',timest(I),' '
      ENDDO
      IF(KINORTOT.EQ.1) then
        WRITE(35,'(1P,SP,(A7,D22.15))')'Energy ',(ETRACK- MASS(JTRACK))
      ELSE 
        WRITE(35,'(1P,SP,(A7,D22.15))')'Energy ',ETRACK 
      ENDIF
      WRITE(35,'(1P,SP,(A7,I3))')'Type   ',JTRACK 
      WRITE(35,'(A12)')'END PARTICLE' 
      END  
      
      
      
      
      
      
      
      
      
           
                      
      
